.Sh TCEMP Xemprc
.Np XEMPRC
A number of quantities can be set in the .xemprc file which will
tailor the behavior of \fItcemp\fP. \fITcemp\fP searches for this file
in the current directory, followed by the user's HOME directory.
Options given at the command line will always override options in your
.xemprc.
.s1
Empty lines and lines starting with a '#' are skipped, also lines starting
with "X " will be skipped. Lines starting with "TC " will be interpreted
without the "TC ". 
.s1
Lines starting with "coun (<country>)" are scanned only if you're
playing as <country>, thus allowing you to set up a .xemprc for more
than one game.
.s1
Lines starting with "term (<termtype>)" are scanned only if you're
working on a <termtype> terminal.
.Np OPTIONS
Here is a list of all of the options tcemp will recognize.
All keywords are case sensitive!
.s1
To define an option, add the line "OPTION=<value>" to your .xemprc
.in 0
.KS
.TS
center,box;
c|s|s
l|l|l.
\fBMail Utility\fP
Option	Values	Description
_
Keep send	Confirm|Yes|No	If you make an announcement
		should this announcement be
		kept in your mailbox?
Keep announce	Confirm|Yes|No	See above
Delete mailbox	Confirm|Yes|No	After reading your mail,
		should \fItcemp\fP delete your 
		mailbox (into the shedder)
Signature	String	This file will be added to
		your telegrams and announcements.
.TE
.KE
.s1
.KS
.TS
center,box;
c|s|s
l|l|l.
\fBStarting up\fP
Option	Values	Description
_
Rescan show	Yes|No	rescan "show build/cap"
		for planes, nukes & ships?
Rescan sonar	Yes|No	rescan sonar?
Rescan land radar	Yes|No
Rescan ship radar	Yes|No
Rescan lookout	Yes|No
Rescan coastwatch	Yes|No
.TE
.KE
.sp 1
.KS
.TS
center,box;
c|s|s
l|l|l.
\fBConnection\fP
Option	Values	Description
_
Silent timeout	Yes|No	Should you notice when \fItcemp\fP
		times out?
Timeout	Numeric	After how many seconds should \fItcemp\fP
		time out? (0 is no timeout)
.TE
.KE
.s1
.KS
.TS
center,box;
c|s|s
l|l|l.
\fBMiscellaneous\fP
Option	Values	Description
_
Compress	Yes|No	Should datafiles be compressed?
Port	String	Which port should \fItcemp\fP connect to?
Host	String	Which host should \fItcemp\fP connect to?
Savelines	Numeric	How many savelines should the
		empire window have?
Buffer	[On|Off|Force]	Use which buffering?
Worldsize	#x#	Worldsize of this game
Capab	ss:ss:ss:ss	Use trycap to add a new entry
Move-prefix	Char	Use <Char> as move-prefix
.TE
.KE
.Np TRYCAP
You should run the program 'trycap' on each terminal type on which you
want to play \fItcemp\fP. This will help you finding out the best highlight
method for each terminal type. Trycap will tell you which line to add to
your .xemprc.
.Np BINDINGS
You can also add bindings to your .xemprc. These are shortcuts, so you
don't have to walk through so many menus before executing a command.
.s1
A list of all possible commands is in "bind/bindings".
.s1
Do not try to rebind the "space", "tab" or "return" keys. They
are used for the buttons.
.sp 1
Format of a bind: \fBBind <Key> to <Command> [<options>]\fP.
.sp 1
Example: Bind M to move (mil).
.Sa bind/bindings
